package com.ibm.websphere.fabric.openacct;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.fabric.da.types.TypedValue;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class CreditCheckContextExtractor implements ContextExtractor {
	
	private static final String ACCTTLIMIT_URI = "http://www.ibm.com/websphere/fabric/stew/extensions#AccountLimit";
	private static final String EMPLOYEETYPE_URI = "http://www.ibm.com/websphere/fabric/stew/extensions#CustomerType";
	
	/**
	 * Default constructor.
	 */
	public CreditCheckContextExtractor() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private ContextExtractor getMyService() {
		return (ContextExtractor) ServiceManager.INSTANCE.locateService("self");
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(PendingRequest arg0) 
	 */
	public Context extractContext(PendingRequest request)
			throws UnexpectedContentException {
		DataObject body = request.getMessageBody();
		System.out.println("+++++++++++++++INSIDE VERIFY CREDIT CONTENT EXTRACTOR++++++++");
		DataObject creditRequest = ((DataObject)body.getSequence(0).getValue(0));
		
		// use this util method to print out the entire SDO tree
		// System.out.println(SdoUtil.printTree(creditRequest));
		
		Float creditLimit = (Float) creditRequest.get("application/requestedCreditLimit");
		String employeeType = (String) creditRequest.get("application/employee/type");
		
		System.out.println("CreditLimit is " + creditLimit);
		System.out.println("Employee Type " + employeeType);
		
		Context context = request.getContext();		
		context.setSelectionProperty(ACCTTLIMIT_URI, new TypedValue(creditLimit.toString()));
		context.setSelectionProperty(EMPLOYEETYPE_URI, new TypedValue(employeeType));
		System.out.println("+++++++++++++++EXITING VERIFY CREDIT CONTENT EXTRACTOR++++++++");
		
		return context;
	}

}