package com.ibm.websphere.fabric.openacct;

import acct602.open.open.acct.bpel.interface_.OpenAcctBPEL;

import com.ibm.websphere.fabric.da.context.InContextServiceInvoker;
import commonj.sdo.DataObject;
import com.ibm.websphere.sca.ServiceManager;

public class OpenAcctContextInjectorImpl2 {
	
	private static final String SUBSCRIPTION_URI = "http://www.webifysolutions.com/context/subscription";
	/**
	 * Default constructor.
	 */
	public OpenAcctContextInjectorImpl2() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "OpenAcctBPELPartner".  This will return an instance of
	 * {@link OpenAcctBPEL}.  If you would like to use this service 
	 * asynchronously then you will need to cast the result
	 * to {@link OpenAcctBPELAsync}.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return OpenAcctBPEL
	 */
	public OpenAcctBPEL locateService_OpenAcctBPELPartner() {
		return (OpenAcctBPEL) ServiceManager.INSTANCE
				.locateService("OpenAcctBPELPartner");
	}

	/**
	 * Method generated to support implemention of operation "processApplication" defined for WSDL port type 
	 * named "interface.OpenAcctBPEL".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public Boolean processApplication(DataObject application) {
		MyInvoker invoker = new MyInvoker(application);
		invoker.inject();
		return (Boolean) invoker.invokeInContext();
	}

	private class MyInvoker extends InContextServiceInvoker {
		private final DataObject _request;
		
		public MyInvoker(DataObject request) {
			_request = request;
		}
		
		void inject() {
			// inspect the soap header or body to get the subscription id
			
			setSelectionProperty(SUBSCRIPTION_URI, "fc://fabric/enrollment/subscription-inst#236de05b-ad57-4584-a747-e74cb60afe99");
		}
		
		public Object invoke() {
			System.out.println("++++++++++++++INSIDE ChannelInjectorImpl ++++++++");
			try {
				return locateService_OpenAcctBPELPartner().processApplication(_request);
			}
			finally {
				System.out.println("++++++++++++++EXITING ChannelInjectorImpl ++++++++");
			}
		}
	}

}